# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%if "%{?rhel}" == "6"
%global _jarsign_opts --nosign --unsign=%{_javadir} 
%bcond_without repolib
%else
%bcond_with repolib
%endif
%bcond_without mead
%define _jarsign_opts --copy=%{_javadir} --unsign=%{_javadir}

%define repodir %{_javadir}/repository.jboss.com/org/jboss/security/jboss-negotiation/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free

%define origtag Final
%define reltag %{origtag}_redhat_1
%define namedversion %{version}.%{origtag}-redhat-1
%define meadversion %{version}.%{reltag}
%define rename jboss-negotiation

%define maven_version 2.2.5.Final-redhat-1

Name:           jboss-security-negotiation
Version:        2.2.5
Release:        1.%{reltag}%{?dist}
Epoch:          0
Summary:        JBoss Security Negotiation
License:        LGPL
Group:          Development/Java

%if %with mead
Source100: org.jboss.security-jboss-negotiation-main-2.2.5.Final-redhat-1-sources.zip
Source101: org.jboss.security-jboss-negotiation-main-2.2.5.Final-redhat-1-patches.zip
Source102: jboss-negotiation-toolkit-2.2.5.Final-redhat-1.war
Source103: jboss-negotiation-toolkit-2.2.5.Final-redhat-1.pom
Source104: jboss-negotiation-toolkit-2.2.5.Final-redhat-1-sources.jar
Source105: jboss-negotiation-net-2.2.5.Final-redhat-1-sources.jar
Source106: jboss-negotiation-net-2.2.5.Final-redhat-1.pom
Source107: jboss-negotiation-net-2.2.5.Final-redhat-1.jar
Source108: jboss-negotiation-main-2.2.5.Final-redhat-1.pom
Source109: jboss-negotiation-common-2.2.5.Final-redhat-1.jar
Source110: jboss-negotiation-common-2.2.5.Final-redhat-1.pom
Source111: jboss-negotiation-common-2.2.5.Final-redhat-1-sources.jar
Source112: jboss-negotiation-spnego-2.2.5.Final-redhat-1.pom
Source113: jboss-negotiation-spnego-2.2.5.Final-redhat-1.jar
Source114: jboss-negotiation-spnego-2.2.5.Final-redhat-1-sources.jar
Source115: jboss-negotiation-extras-2.2.5.Final-redhat-1.jar
Source116: jboss-negotiation-extras-2.2.5.Final-redhat-1.pom
Source117: jboss-negotiation-extras-2.2.5.Final-redhat-1-sources.jar
Source118: jboss-negotiation-project-2.2.5.Final-redhat-1.pom
Source119: jboss-negotiation-ntlm-2.2.5.Final-redhat-1-sources.jar
Source120: jboss-negotiation-ntlm-2.2.5.Final-redhat-1.pom
Source121: jboss-negotiation-ntlm-2.2.5.Final-redhat-1.jar
%endif

URL:            http://www.jboss.org/
# svn export https://svn.jboss.org/repos/jbossas/projects/security/security-negotiation/tags/security-negotiation-2.0.3.SP03 jboss-security-negotiation-2.0.3.SP3
# Exported revision 105678.
# tar czf jboss-security-negotiation-2.0.3.SP3.tar.gz jboss-security-negotiation-2.0.3.SP3
%if %without mead
Source0:        jboss-security-negotiation-2.0.3.SP3.tar.gz
Source1:        jboss-security-negotiation-jpp-depmap.xml

BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-jboss-deploy-plugin
BuildRequires:  maven-release-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  junit
BuildRequires:  jboss-common-core
BuildRequires:  jboss-parent
# jboss5-libs has poms that incorrectly bring all but the kitchen sink
#BuildRequires:  jboss5-libs
# Using jbossas directly for now
BuildRequires:  jbossas
#BuildRequires:  jbosssx2
#BuildRequires:  jbossweb
#BuildRequires:  log4j-eap6
BuildRequires:  xpp3-minimal
%endif

Requires:  java
#Requires:  jboss-common-core
#Requires:  jbosssx2
Requires:  jbossweb
#Requires:  log4j

Requires(post): jpackage-utils
Requires(postun): jpackage-utils

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss Security Negotiation.

%if %without mead
%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation


%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif
%endif

%prep
%if %without mead
%setup -q -n %{name}-%{namedversion}
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm} -f
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
export MAVEN_OPTS="-Dmaven.repo.local=$MAVEN_REPO_LOCAL -Dmaven2.jpp.depmap.file=%{SOURCE1} -Daggregate=true"

mvn-jpp -e \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        install deploy:deploy

mvn-jpp -e \
        javadoc:javadoc
%endif

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
%if %without mead
install -m 644 assembly/target/jboss-negotiation.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-%{namedversion}.jar
install -m 644 jboss-negotiation-common/target/jboss-negotiation-common.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-common-%{namedversion}.jar
install -m 644 jboss-negotiation-extras/target/jboss-negotiation-extras.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-extras-%{namedversion}.jar
install -m 644 jboss-negotiation-ntlm/target/jboss-negotiation-ntlm.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-ntlm-%{namedversion}.jar
install -m 644 jboss-negotiation-spnego/target/jboss-negotiation-spnego.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-spnego-%{namedversion}.jar
%else

%{__cp} -p %{_sourcedir}/%{rename}-common-%{namedversion}.jar %{buildroot}%{_javadir}
%{__cp} -p %{_sourcedir}/%{rename}-common-%{namedversion}-sources.jar %{buildroot}%{_javadir}

%{__cp} -p %{_sourcedir}/%{rename}-extras-%{namedversion}.jar %{buildroot}%{_javadir}
%{__cp} -p %{_sourcedir}/%{rename}-extras-%{namedversion}-sources.jar %{buildroot}%{_javadir}

%{__cp} -p %{_sourcedir}/%{rename}-net-%{namedversion}.jar %{buildroot}%{_javadir}
%{__cp} -p %{_sourcedir}/%{rename}-net-%{namedversion}-sources.jar %{buildroot}%{_javadir}

%{__cp} -p %{_sourcedir}/%{rename}-ntlm-%{namedversion}.jar %{buildroot}%{_javadir}
%{__cp} -p %{_sourcedir}/%{rename}-ntlm-%{namedversion}-sources.jar %{buildroot}%{_javadir}

%{__cp} -p %{_sourcedir}/%{rename}-spnego-%{namedversion}.jar %{buildroot}%{_javadir}
%{__cp} -p %{_sourcedir}/%{rename}-spnego-%{namedversion}-sources.jar %{buildroot}%{_javadir}

%{__cp} -p %{_sourcedir}/%{rename}-toolkit-%{namedversion}-sources.jar %{buildroot}%{_javadir}
%endif

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{namedversion}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{namedversion}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
%if %without mead
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{rename}-main.pom
install -m 644 parent/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{rename}-project.pom
install -m 644 assembly/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{rename}.pom
install -m 644 jboss-negotiation-common/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{rename}-common.pom
install -m 644 jboss-negotiation-extras/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{rename}-extras.pom
install -m 644 jboss-negotiation-ntlm/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{rename}-ntlm.pom
install -m 644 jboss-negotiation-spnego/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{rename}-spnego.pom
%else
%{__cp} -p %{_sourcedir}/%{rename}-main-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{rename}-main.pom
%{__cp} -p %{_sourcedir}/%{rename}-project-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{rename}-project.pom
%{__cp} -p %{_sourcedir}/%{rename}-common-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{rename}-common.pom
%{__cp} -p %{_sourcedir}/%{rename}-extras-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{rename}-extras.pom
%{__cp} -p %{_sourcedir}/%{rename}-net-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{rename}-net.pom
%{__cp} -p %{_sourcedir}/%{rename}-ntlm-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{rename}-ntlm.pom
%{__cp} -p %{_sourcedir}/%{rename}-spnego-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{rename}-spnego.pom
%{__cp} -p %{_sourcedir}/%{rename}-toolkit-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{rename}-toolkit.pom
%endif

# war
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}-%{version}
%if %without mead
install -m 644 jboss-negotiation-toolkit/target/jboss-negotiation-toolkit.war $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
%else
%{__cp} -p %{_sourcedir}/%{rename}-toolkit-%{namedversion}.war %{buildroot}%{_datadir}/%{name}-%{version}
%endif

# depmaps
%add_to_maven_depmap org.jboss.security jboss-negotiation-project %{namedversion} JPP %{rename}-project
%add_to_maven_depmap org.jboss.security jboss-negotiation-main %{namedversion} JPP %{rename}-main
%add_to_maven_depmap org.jboss.security jboss-negotiation-common %{namedversion} JPP %{rename}-common
%add_to_maven_depmap org.jboss.security jboss-negotiation-extras %{namedversion} JPP %{rename}-extras
%add_to_maven_depmap org.jboss.security jboss-negotiation-net %{namedversion} JPP %{rename}-net
%add_to_maven_depmap org.jboss.security jboss-negotiation-ntlm %{namedversion} JPP %{rename}-ntlm
%add_to_maven_depmap org.jboss.security jboss-negotiation-spnego %{namedversion} JPP %{rename}-spnego
%add_to_maven_depmap org.jboss.security jboss-negotiation-toolkit %{namedversion} JPP %{rename}-toolkit

%if %without mead
# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{namedversion}
cp -rf target/site/apidocs/* \
                  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{namedversion}
ln -s %{name}-%{namedversion} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
%endif

%if %without mead
%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}.jar $RPM_BUILD_ROOT%{repodirlib}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-common.jar $RPM_BUILD_ROOT%{repodirlib}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-extras.jar $RPM_BUILD_ROOT%{repodirlib}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-ntlm.jar $RPM_BUILD_ROOT%{repodirlib}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-spnego.jar $RPM_BUILD_ROOT%{repodirlib}

cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-main.pom $RPM_BUILD_ROOT%{repodirlib}/%{name}-main.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-project.pom $RPM_BUILD_ROOT%{repodirlib}/%{name}-project.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom $RPM_BUILD_ROOT%{repodirlib}/%{name}.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-common.pom $RPM_BUILD_ROOT%{repodirlib}/%{name}-common.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-extras.pom $RPM_BUILD_ROOT%{repodirlib}/%{name}-extras.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-ntlm.pom $RPM_BUILD_ROOT%{repodirlib}/%{name}-ntlm.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-spnego.pom $RPM_BUILD_ROOT%{repodirlib}/%{name}-spnego.pom
%endif
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%{_datadir}/%{name}-%{version}

%if %without mead
%files javadoc
%defattr(-,root,root,-)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}
%endif

%if %without mead
%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif
%endif

%changelog
* Tue May 07 2013 Vladimir Dosoudil <dosoudil@redhat.com> - 0:2.2.5-1.Final_redhat_1
- Upgrade to 2.2.5.Final

* Mon May 06 2013 Vladimir Dosoudil <dosoudil@redhat.com> - 0:2.2.4-1.Final_redhat_1
- Upgrade to 2.2.4.Final

* Wed Apr 24 2013 Vladimir Dosoudil <dosoudil@redhat.com> - 0:2.2.3-1.Final_redhat_1
- Upgrade to 2.2.3.Final

* Thu Mar 07 2013 Fernando Nasser <fnasser@redhat.com> - 0:2.2.1-2.Final_redhat_1.1
- Remove dependencies for EAP 5 bits or things that are "provided" by the server

* Sun Feb 17 2013 Lin Gao <lgao@redhat.com> - 0:2.2.2-1.Final_redhat_1
- Upgrade to 2.2.2.Final

* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.2.1-2.Final_redhat_1
- Rebuild for MD5

* Fri Aug 17 2012 Lin Gao <lgao@redhat.com> - 0:2.2.1-1.Final_redhat_1
- Upgrade to 2.2.1.Final

* Sun Aug 12 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.2.0-1.SP1_redhat_2.2
- Rebuild unsigned

* Thu Jul 12 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.2.0-1.SP1_redhat_1.1
- Rebuild using cache signing

* Tue May 22 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.2.0-1.SP1_redhat_1
- Remove javadoc from SRPM and disable javadoc subpackage

* Fri Mar 16 2012 Lin Gao <lgao@redhat.com> - 0:2.2.0-0.6.SP1_redhat_1
- use new wrapper
- change jars install path

* Thu Feb 16 2012 Lin Gao <lgao@redhat.com> - 0:2.2.0-0.5.SP1_redhat_1
- upgrade to 2.2.0.SP1
- no assemble artifact in 2.2.0.SP1
- use javadoc:aggregate-jar

* Tue Feb 07 2012 Red Hat Release Engineering <release-engineering@redhat.com> - 0:2.2.0-0.4.Beta3_redhat_1
- Rebuild to use new signing key

* Wed Feb 01 2012 Hui Wang <huwang@redhat.com> - 0:2.2.0-0.3.Beta3_redhat_1
- RPM build

* Thu Dec 09 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.3-2.SP3.3
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR maven-deploy-plugin, maven-site-plugin, xpp3-minimal

* Thu Jun 3 2010 Yiqiao Wang <yiwang@redhat.com> - 0:2.0.3-2.SP3.2
- Merge From RHEL4

* Thu May 27 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.0.3-2.SP3.2
- Fix repolib location
- Do not include repolib content in main rpm

* Thu May 27 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.0.3-2.SP3.1
- Update to SP3

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.3-1.SP2.6.1
- rebuilt

* Wed Apr 21 2010 Hui Wang <huwang@redhat.com> - 0:2.0.3-1.SP2.6
- Rebuild

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> - 0:2.0.3-1.SP2.5
- Rebuild

* Tue Dec 01 2009 Yong Yang <yyang@redhat.com> - 0:2.0.3-1.SP2.4
- Change version in poms from 2.0.3.SP02 to 2.0.3.SP2

* Wed Nov 11 2009 Yong Yang <yyang@redhat.com> - 0:2.0.3-1.SP2.3
- Use namedversion(not version) to replace the @VERSION@ of component-info.xml 

* Tue Nov 10 2009 Yong Yang <yyang@redhat.com> - 0:2.0.3-1.SP2.2
- Add repolib

* Fri Sep 11 2009 Fernando Nasser <fnasser@redhat.com> - 0:2.0.3-1.SP2.1
- Update to SP2

* Tue Sep 08 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.0.3.1-1
- first release
